﻿namespace Polecenie
{
    internal interface IPolecenie
    {
        bool CzyMożnaWykonać();
        void Wykonaj();
    }

    class PoleceniePrzelewu : IPolecenie
    {
        private Konto kontoPłatnika, kontoOdbiorcy;
        private decimal kwota;
        private bool wykonany = false;

        public PoleceniePrzelewu(Konto kontoPłatnika, Konto kontoOdbiorcy, decimal kwota)
        {
            this.kontoPłatnika = kontoPłatnika;
            this.kontoOdbiorcy = kontoOdbiorcy;
            this.kwota = kwota;
        }

        public bool CzyMożnaWykonać()
        {
            return !wykonany && kwota > 0;
        }

        public void Wykonaj()
        {
            if (wykonany) throw new Exception("Polecenie przelewu zostało już zrealizowane");
            Konto.Przelew(kontoPłatnika, kontoOdbiorcy, kwota);
            wykonany = true;
        }
    }
}