﻿using System;
using System.Windows.Input;

namespace Polecenie
{
    class Program
    {
        static void Main(string[] args)
        {
            try //powinno być wokół każdego przelewu osobno
            {
                Konto konto1 = new Konto(1, 100);
                Konto konto2 = new Konto(2, 150);

                konto1.WyświetlSaldo();
                konto2.WyświetlSaldo();

                //Konto.Przelew(konto1, konto2, 50);
                //IPolecenie polecenieA = new PoleceniePrzelewu(konto1, konto2, 50);

                DanePrzelewu daneA = new DanePrzelewu()
                {
                    KontoPłatnika = konto1,
                    KontoOdbiorcy = konto2,
                    Kwota = 50
                };

                konto1.WyświetlSaldo();
                konto2.WyświetlSaldo();

                //Konto.Przelew(konto2, konto1, 100);
                //IPolecenie polecenieB = new PoleceniePrzelewu(konto2, konto1, 100);

                DanePrzelewu daneB = new DanePrzelewu()
                {
                    KontoPłatnika = konto2,
                    KontoOdbiorcy = konto1,
                    Kwota = 100
                };                

                ICommand poleceniePrzelewu = new RelayCommand(
                    (object parametr) =>
                    {
                        DanePrzelewu dane = (DanePrzelewu)parametr;
                        if (dane.Wykonany) throw new Exception("Polecenie przelewu zostało już zrealizowane");
                        Konto.Przelew(dane.KontoPłatnika, dane.KontoOdbiorcy, dane.Kwota);
                        dane.Wykonany = true;                        
                    },
                    (object parametr) =>
                    {
                        DanePrzelewu dane = (DanePrzelewu)parametr;
                        return !dane.Wykonany && dane.Kwota > 0;
                    }
                );

                if (poleceniePrzelewu.CanExecute(daneA)) poleceniePrzelewu.Execute(daneA);
                else Console.Error.WriteLine("Polecenie z daneA nie może być zrealizowane");

                konto1.WyświetlSaldo();
                konto2.WyświetlSaldo();

                //if (polecenieB.CzyMożnaWykonać()) polecenieB.Wykonaj();
                //else Console.Error.WriteLine("Polecenie B nie może być zrealizowane");

                if (poleceniePrzelewu.CanExecute(daneB)) poleceniePrzelewu.Execute(daneB);
                else Console.Error.WriteLine("Polecenie z daneB nie może być zrealizowane");

                konto1.WyświetlSaldo();
                konto2.WyświetlSaldo();                
            }
            catch (Exception exc)
            {
                Console.Error.WriteLine("Błąd: " + exc.Message);
            }
        }
    }
}
