﻿using System.Windows.Input;

namespace Polecenie
{
    class DanePrzelewu //DTO
    {
        public Konto KontoPłatnika, KontoOdbiorcy;
        public decimal Kwota;
        public bool Wykonany = false;
    }

    internal class RelayCommand : ICommand
    {
        private readonly Action<object?> execute;
        private readonly Predicate<object?> canExecute;

        public RelayCommand(Action<object?> execute, Predicate<object?> canExecute = null)
        {
            if(execute == null) throw new ArgumentNullException(nameof(execute));
            this.execute = execute;
            this.canExecute = canExecute;
        }

        public bool CanExecute(object? parameter)
        {
            if (canExecute != null) return canExecute(parameter); else return true;
        }

        public void Execute(object? parameter)
        {
            execute(parameter);
        }

        public event EventHandler? CanExecuteChanged
        {
            add 
            {
                //if (canExecute != null) CommandManager.RequerySuggested += value;
            } 
            remove 
            {
                //if (canExecute != null) CommandManager.RequerySuggested -= value;
            }

        }
    }
}
